// C Source File
// Created 5/3/01; 6:53:48 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization
#define USE_LONGDIV_PATCH     // Enables the program to use long division
#define USE_LONGMUL_PATCH

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

int _ti92plus;                // Produce .9XZ File

int get_key(void)
{
  void *kbq = kbd_queue();
  int key;
   if (OSTimerExpired(APD_TIMER))
   {
   off();
   OSTimerRestart(APD_TIMER);
   }
   if (!OSdequeue(&key, kbq)) OSTimerRestart (APD_TIMER);
  return key & 0xf7ff;  // mask out 0x800 (repeat flag)
}

void teach(void)
{
	off();
}

void DrawMainScrn(int pins[10])
{
  static unsigned char pin[] = {0x00,0x0E,0x11,0x11,0x11,0x0E,0x00};
  ClrScr();
  _box (0,13,239,115);
  DrawLine(226,13,226,115,A_NORMAL);
  DrawLine (10,13,25,0,A_NORMAL);
  DrawLine (10,115,25,127,A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr (30,37,">>",A_NORMAL);
	DrawStr (40,50,">>",A_NORMAL);
	DrawStr (50,62,">>",A_NORMAL);
	DrawStr (40,74,">>",A_NORMAL);
	DrawStr (30,86,">>",A_NORMAL);
	DrawStr (30,120,"Score:",A_REPLACE);
	DrawStr (30,5,"Frame:",A_NORMAL);
	DrawStr (110,5,"Ball:",A_NORMAL);
	Sprite8 (51, 180, 7, pin, LCD_MEM, SPRT_XOR);
	if (pins[0]==1) Sprite8 (180,61,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[1]==1) Sprite8 (190,55,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[2]==1) Sprite8 (190,67,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[3]==1) Sprite8 (200,49,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[4]==1) Sprite8 (200,61,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[5]==1) Sprite8 (200,73,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[6]==1) Sprite8 (210,43,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[7]==1) Sprite8 (210,55,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[8]==1) Sprite8 (210,67,7,pin,LCD_MEM,SPRT_XOR);
	if (pins[9]==1) Sprite8 (210,79,7,pin,LCD_MEM,SPRT_XOR);
	;
}

void _box(int a, int b, int c, int d)
{
	DrawLine (a,b,a,d,A_NORMAL);
	DrawLine (a,b,c,b,A_NORMAL);
	DrawLine (c,b,c,d,A_NORMAL);
	DrawLine (a,d,c,d,A_NORMAL);
}

void sleep(unsigned int a)
{
  unsigned long int b;
	for (b = 0; b<a*1000; b++)
	{
		
	}
}

// Main Function
void _main(void)
{
	int a,b;
  static int level = 1;
	char name [40];
	char txt [50];
	static int hscorenumb[6] = {20,20,20,20,20,20};
	static char *hsc1 = NULL;
	static char *hsc2 = NULL;
	static char *hsc3 = NULL;
	static char *hsc4 = NULL;
	static char *hsc5 = NULL;
begin:
	ClrScr();
	FontSetSys (F_8x10);
	DrawStr(70,5,"B O W L I N G",A_NORMAL);
	DrawLine (60,15,188,15,A_NORMAL);
  _box (2,2,238,126);
	FontSetSys (F_6x8);
	DrawStr (45,25,"C Version 1.0 by MurBeck",A_NORMAL);
	DrawStr (25,35,"Main Prgm: Stephen Schloterbeck",A_NORMAL);
	DrawStr (50,50,"Level:  ",A_REPLACE);
	a = 0;
	DrawStr (70, 75, hsc1, A_NORMAL);
	DrawStr (70, 85, hsc2, A_NORMAL);
	DrawStr (70, 95, hsc3, A_NORMAL);
	DrawStr (70, 105, hsc4, A_NORMAL);
	DrawStr (70, 115, hsc5, A_NORMAL);	
	for (a = 1; a<6; a++)
	{
	 sprintf (txt, "%d", hscorenumb[a-1]);
	 DrawStr (175,65+10*a, txt, A_NORMAL);
	}
	while (a != 13)
	{
	 sprintf (txt, "%d", level);
 	 DrawStr (90,50,txt,A_REPLACE);
	 DrawStr (40,65,"Highscores:",A_NORMAL);
	 a = ngetchx();
	 if (a == 116 || a == 32) teach();
	 if (a == 264) return;
	 if (a == 344 && level>1) level = level-1;
	 if (a == 338 && level<5) level = level+1;
  }
	DrawMainScrn(0);
	a = play(level);
	ClrScr();
	FontSetSys (F_8x10);
	_box (66,29,178,75);
	DrawStr (75,33,"Final Score:",A_NORMAL);
	sprintf (txt, "%d", a);
	DrawStr (107,54,txt,A_NORMAL);
	FontSetSys(F_6x8);
	if (a > hscorenumb[level-1])
	{
		hscorenumb[level-1] = a;
		for (a=0;a<40;a++) name[a] = 0;
		DrawStr (45, 80, "!New HighScore! Enter Name:", A_NORMAL);
		a = 0;
		b = 0;
		while (a != 13)
		{
			a = ngetchx();
			if (a == 13) goto done;
			DrawStr (80,90,"                ",A_REPLACE);
			if (a == 257)
			{
			 if (b > 0) 
			 {
			  b = b-1;
 			  name[b] = 0;
 			 }
 			}
			if (b < 14 && a != 257)
			{
			name[b] = a;
			if (b < 13) b = b+1;
			}
			DrawStr (119-b*3,90,name,A_NORMAL);
		}
done:
	if (level == 1) hsc1 = name;
	if (level == 2) hsc2 = name;
	if (level == 3) hsc3 = name;
	if (level == 4) hsc4 = name;
	if (level == 5) hsc5 = name;
	}
	DrawStr (30,115,"[ENTER]-new game [ESCAPE]-exit",A_NORMAL);
	a = ngetchx();
	if (a == 13) goto begin;
	return;
}

int play(int lvl)
{
	int score;
	unsigned int a,b,key,rnd,trn,up;
	char txt [50];
  static int pins[10] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
  static unsigned ball[] = {0x00,0x38,0x4C,0xBE,0xFE,0xFE,0x7C,0x38,0x00};
  static unsigned mask[] = {~0xFF,~0x38,~0x7C,~0xFE,~0xFE,~0xFE,~0x7C,~0x38,~0xFF};
  rnd = 0;
  score = 0;
begin1:
if (rnd > 9) goto End;
 rnd = rnd + 1;
 for (a = 0; a < 10; a++)
  pins[a] = 1;
 for (trn = 1; trn < 3; trn++)
 {
   DrawMainScrn(pins);
	 for (a=0; a<rnd; a++)
	 	{
	 		DrawLine (57+a*4,5,57+a*4,9,A_NORMAL);
	 		DrawLine (58+a*4,5,58+a*4,9,A_NORMAL);
	 	}
	 sprintf (txt, "%d", score);
	 DrawStr (66,120,txt,A_REPLACE);
   Sprite16 (131,3,9,ball,LCD_MEM,SPRT_XOR);
	 if (trn==1)	Sprite16 (131+9,3,9,ball,LCD_MEM,SPRT_XOR);
Bowl:
   key = 0;
	 for (up=17; up<102; up++)
	 {
	 Sprite16 (6,up,9,ball,LCD_MEM,SPRT_XOR);
	 sleep(6-lvl);
	 key = get_key();
   if (key == 116 || key == 32 || key == 272) teach();
	 if (key == 264 || key == 4360) goto End;	
	 if (key == 13 || key == 268) goto Shoot;
 	 Sprite16 (6,up,9,ball,LCD_MEM,SPRT_XOR);
	 }
	 for (up=102; up>17; up--)
	 {
	 Sprite16 (6,up,9,ball,LCD_MEM,SPRT_XOR);
	 sleep(6-lvl);
	 key = get_key();
	 if (key == 116 || key == 32 || key == 272) teach();
	 if (key == 264 || key == 4360) goto End;
	 if (key == 13 || key == 268) goto Shoot;
	 Sprite16 (6,up,9,ball,LCD_MEM,SPRT_XOR);
	 }
 goto Bowl;
Shoot:
  for (b=7; b<221; b++)
  {
	 Sprite16 (b-1,up,9,ball,LCD_MEM,SPRT_XOR);
 	 Sprite16 (b,up,9,ball,LCD_MEM,SPRT_XOR);
   sleep(1);
  }
  up = up+3;
  if (up < 40 || up > 91)
  {
  FontSetSys(F_8x10);
  DrawStr (60,59,"?GUTTERBALL?",A_REPLACE);
  }
  if (up>47+13 && up<55+13 && up!=51+13)
  {
   if (trn == 2) goto spare;
   FontSetSys(F_8x10);
   DrawStr (65,59,"X!!STRIKE!!X",A_REPLACE);
   score = score + 30;
   goto sumup2;
spare:
   if (pins[0] == 0) goto cont;
spare2:
   FontSetSys(F_8x10);
   DrawStr (70,59,"//!Spare!//",A_REPLACE);
   score = score + 20;
   goto sumup2;
  }
cont:
  if (up>39+13 && up<51+13) pins[1] = 0;
  if (up>51+13 && up<63+13) pins[2] = 0;
  if (up>33+13 && up<50+13) pins[3] = 0;
  if (up>45+13 && up<57+13) pins[4] = 0;
  if (up>52+13 && up<69+13) pins[5] = 0;
  if (up>36 && up<49) pins[6] = 0;
  if (up>36+13 && up<51+13) pins[7] = 0;
  if (up>51+13 && up<63+13) pins[8] = 0;
  if (up>63+13 && up<75+13) pins[9] = 0;
  if (up>36 && up<49) pins[9] = 0;
  if (up<75+13 && up>69+13) pins[6] = 0;
  if (up == 64)
  {
  	pins[0] = 0;
  	pins[1] = 0;
  	pins[2] = 0;
  	pins[3] = 0;
  	pins[4] = 0;
  	pins[5] = 0;
  	pins[7] = 0;
  	pins[8] = 0;
  }
  if (pins[0] == 0 && pins[1] == 0 && pins[2] == 0 && pins[3] == 0 && pins[4] == 0 && pins[5] == 0) if (pins[6] == 0 && pins[7] == 0 && pins[8] == 0 && pins[9] == 0) goto spare2;
  DrawMainScrn(pins);
 }
 score = score+10-pins[0]-pins[1]-pins[2]-pins[3]-pins[4]-pins[5]-pins[6]-pins[7]-pins[8]-pins[9];
sumup2:
ngetchx();
goto begin1;
End:
	return score;
}
